net.sf.saxon.trans

## Class DynamicLoader

- java.lang.Object
- - net.sf.saxon.trans.DynamicLoader

-     public class DynamicLoader
      extends Object

  Utility class used to perform dynamic loading of user-hook implementations

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected HashMap<String,Class>` | `knownClasses`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DynamicLoader()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Class` | `getClass(String className, PrintStream traceOut, ClassLoader classLoader)` Load a class using the class name provided.
    `ClassLoader` | `getClassLoader()` Get the ClassLoader supplied using the method `setClassLoader(java.lang.ClassLoader)`.
    `Object` | `getInstance(String className, ClassLoader classLoader)` Instantiate a class using the class name provided.
    `Object` | `getInstance(String className, PrintStream traceOut, ClassLoader classLoader)` Instantiate a class using the class name provided, with the option of tracing Note that the method does not check that the object is of the right class.
    `protected void` | `registerKnownClasses()` Register classes that might be dynamically loaded even though they are contained within Saxon itself.
    `void` | `setClassLoader(ClassLoader loader)` Set a ClassLoader to be used when loading external classes.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### knownClasses

          protected HashMap<String,Class> knownClasses

  - ### Constructor Detail

    - #### DynamicLoader

          public DynamicLoader()

  - ### Method Detail

    - #### registerKnownClasses

          protected void registerKnownClasses()

      Register classes that might be dynamically loaded even though they are contained within Saxon itself. This typically occurs for default implementations of classes that can be substituted or subclassed by the user.

    - #### setClassLoader

          public void setClassLoader(ClassLoader loader)

      Set a ClassLoader to be used when loading external classes. Examples of classes that are loaded include SAX parsers, localization modules for formatting numbers and dates, extension functions, external object models. In an environment such as Eclipse that uses its own ClassLoader, this ClassLoader should be nominated to ensure that any class loaded by Saxon is identical to a class of the same name loaded by the external environment.

      Parameters:
        `loader` - the ClassLoader to be used in this configuration

    - #### getClassLoader

          public ClassLoader getClassLoader()

      Get the ClassLoader supplied using the method `setClassLoader(java.lang.ClassLoader)`. If none has been supplied, return null.

      Returns:
        the ClassLoader used in this configuration

    - #### getClass

          public Class getClass(String className,
                       PrintStream traceOut,
                       ClassLoader classLoader)
                         throws XPathException

      Load a class using the class name provided. Note that the method does not check that the object is of the right class.

      This method is intended for internal use only.

      Parameters:
        `className` - A string containing the name of the class, for example "com.microstar.sax.LarkDriver"
        `traceOut` - if diagnostic tracing is required, the destination for the output; otherwise null
        `classLoader` - The ClassLoader to be used to load the class. If this is null, then the classLoader used will be the first one available of: the classLoader registered with the Configuration using `setClassLoader(java.lang.ClassLoader)`; the context class loader for the current thread; or failing that, the class loader invoked implicitly by a call of Class.forName() (which is the ClassLoader that was used to load the Configuration object itself).
      Returns:
        an instance of the class named, or null if it is not loadable.
      Throws:
        `XPathException` - if the class cannot be loaded.

    - #### getInstance

          public Object getInstance(String className,
                           ClassLoader classLoader)
                             throws XPathException

      Instantiate a class using the class name provided. Note that the method does not check that the object is of the right class.

      This method is intended for internal use only.

      Parameters:
        `className` - A string containing the name of the class, for example "com.microstar.sax.LarkDriver"
        `classLoader` - The ClassLoader to be used to load the class. If this is null, then the classLoader used will be the first one available of: the classLoader registered with the Configuration using `setClassLoader(java.lang.ClassLoader)`; the context class loader for the current thread; or failing that, the class loader invoked implicitly by a call of Class.forName() (which is the ClassLoader that was used to load the Configuration object itself).
      Returns:
        an instance of the class named, or null if it is not loadable.
      Throws:
        `XPathException` - if the class cannot be loaded.

    - #### getInstance

          public Object getInstance(String className,
                           PrintStream traceOut,
                           ClassLoader classLoader)
                             throws XPathException

      Instantiate a class using the class name provided, with the option of tracing Note that the method does not check that the object is of the right class.

      This method is intended for internal use only.

      Parameters:
        `className` - A string containing the name of the class, for example "com.microstar.sax.LarkDriver"
        `traceOut` - if attempts to load classes are to be traced, then the destination for the trace output; otherwise null
        `classLoader` - The ClassLoader to be used to load the class. If this is null, then the classLoader used will be the first one available of: the classLoader registered with the Configuration using `setClassLoader(java.lang.ClassLoader)`; the context class loader for the current thread; or failing that, the class loader invoked implicitly by a call of Class.forName() (which is the ClassLoader that was used to load the Configuration object itself).
      Returns:
        an instance of the class named, or null if it is not loadable.
      Throws:
        `XPathException` - if the class cannot be loaded.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.